%global momorel 1

%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?gtk_binary_version: %global gtk_binary_version %(pkg-config --variable=gtk_binary_version gtk+-2.0)}

%global glib_ver %([ -a %{_libdir}/pkgconfig/glib-2.0.pc ] && pkg-config --modversion glib-2.0 | cut -d. -f 1,2 || echo -n "999")
%global gconf2_version 2.12.0
%global dbus_python_version 0.83.0
%global im_chooser_version 1.2.5
%global qtver 4.5.2
%global _xinputconf %{_sysconfdir}/X11/xinit/xinput.d/ibus.conf

Summary: Intelligent Input Bus for Linux OS
Name: ibus
Version: 1.3.9
Release: %{momorel}m%{?dist}
License: LGPLv2+
Group: System Environment/Libraries
URL: http://code.google.com/p/ibus/
Source0: http://ibus.googlecode.com/files/%{name}-%{version}.tar.gz
NoSource: 0
Source1: xinput-ibus
Source2: xinput-ibus-qt3
# Patch0: %%{name}-%%{version}-build-qt4-immodule.patch
Patch1: ibus-1.3.8-shift-space.patch
Patch2: ibus-1.3.7-panel-show.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post): GConf2 >= %{gconf2_version}
Requires(post): chkconfig
Requires(post): coreutils
Requires(post): desktop-file-utils
Requires(post): gtk2
Requires(pre): GConf2 >= %{gconf2_version}
Requires(preun): GConf2 >= %{gconf2_version}
Requires(postun): chkconfig
Requires(postun): coreutils
Requires(postun): desktop-file-utils
Requires(postun): gtk2
Requires: %{name}-libs = %{version}-%{release}
Requires: %{name}-gtk = %{version}-%{release}
Requires: GConf2 >= %{gconf2_version}
Requires: dbus-python >= %{dbus_python_version}
Requires: gnome-python2-gconf
# for directory ownership
Requires: gobject-introspection
# XXX: temporarily disable on momonga only
# Requires: im-chooser >= %%{im_chooser_version}
Requires: iso-codes
Requires: pygtk2
Requires: pyxdg
# for directory ownership
Requires: vala
BuildRequires: GConf2-devel
BuildRequires: automake
BuildRequires: cvs
BuildRequires: dbus-glib-devel
BuildRequires: dbus-python-devel >= %{dbus_python_version}
BuildRequires: desktop-file-utils
BuildRequires: gettext-devel
BuildRequires: gobject-introspection-devel
BuildRequires: gtk-doc
BuildRequires: gtk2-devel
BuildRequires: intltool
BuildRequires: libtool
BuildRequires: pygobject-devel
BuildRequires: python
BuildRequires: vala-devel
# BuildRequires: qt-devel = %%{qtver}
Obsoletes: ibus-qt < 1.1.0

%description
IBus means Intelligent Input Bus. It is a new input framework for Linux OS. It provides
full featured and user friendly input method user interface. It also may help
developers to develop input method easily.

%package libs
Summary: IBus libraries
Group: System Environment/Libraries
Requires: dbus >= 1.2.4
Requires: glib2 >= %{glib_ver}

%description libs
This package contains the libraries for IBus.

%package gtk
Summary: IBus im module for gtk2
Group: System Environment/Libraries
Requires(post): glib2 >= %{glib_ver}
Requires(post): gtk2 >= 2.20.1-5m
Requires(postun): gtk2 >= 2.20.1-5m
Requires: %{name} = %{version}-%{release}

%description gtk
This package contains ibus im module for gtk2.

%if 0
%package qt
Summary: IBus im module for qt4
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}
Requires: qt = %{qtver}

%description qt
This package contains ibus im module for qt4.
%endif

%package devel
Summary: Development tools for ibus
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: glib2-devel
Requires: dbus-devel

%description devel
The ibus-devel package contains the header files and developer
docs for ibus.

%package devel-docs
Summary: Developer documents for ibus
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: gtk-doc

%description devel-docs
The ibus-devel-docs package contains developer documentation for ibus.

%prep
%setup -q
# %%patch0 -p1 -b .build-qt4-immodule
%patch1 -p1 -b .shift-space
%patch2 -p1 -b .panel-show

gtkdocize --copy
autoreconf -vfi

%build
%configure --disable-static \
    --disable-iso-codes-check \
    --enable-gtk-doc \
    --disable-qt4-immodule
%make

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

# get rid of *.la files
rm -f %{buildroot}%{_libdir}/libibus*.la
rm -f %{buildroot}%{_libdir}/gtk-2.0/%{gtk_binary_version}/immodules/im-ibus.la

# install xinput config file
install -pm 644 -D %{SOURCE1} %{buildroot}%{_xinputconf}

# XXX: momonga specific
install -pm 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/X11/xinit/xim.d/ibus
install -pm 644 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/X11/xinit/xim.d/ibus-qt3

# install .desktop files
echo "NoDisplay=true" >> %{buildroot}%{_datadir}/applications/ibus.desktop
echo "NoDisplay=true" >> %{buildroot}%{_datadir}/applications/ibus-setup.desktop
echo "X-GNOME-Autostart-enabled=false" >> %{buildroot}%{_sysconfdir}/xdg/autostart/ibus.desktop
rm -f %{buildroot}%{_sysconfdir}/xdg/autostart/ibus.desktop
desktop-file-install --delete-original --vendor= \
  --dir %{buildroot}%{_datadir}/applications \
    %{buildroot}%{_datadir}/applications/*

%find_lang %{name}

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
# recreate icon cache
touch --no-create %{_datadir}/icons/hicolor || :
[ -x %{_bindir}/gtk-update-icon-cache ] && \
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :

# XXX: temporarily disable on momonga only
%if 0
%{_sbindir}/alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_xinputconf} 83 || :
%endif

export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/ibus.schemas >& /dev/null || :

%pre
if [ "$1" -gt 1 ]; then
	export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
	gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/ibus.schemas >& /dev/null || :
fi

%preun
if [ "$1" -eq 0 ]; then
	export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
	gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/ibus.schemas >& /dev/null || :
fi

%postun
# recreate icon cache
touch --no-create %{_datadir}/icons/hicolor || :
[ -x %{_bindir}/gtk-update-icon-cache ] && \
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :

# XXX: temporarily disable on momonga only
%if 0
if [ "$1" = "0" ]; then
  %{_sbindir}/alternatives --remove xinputrc %{_xinputconf} || :
  # if alternative was set to manual, reset to auto
  [ -L %{_sysconfdir}/alternatives/xinputrc -a "`readlink %{_sysconfdir}/alternatives/xinputrc`" = "%{_xinputconf}" ] && %{_sbindir}/alternatives --auto xinputrc || :
fi
%endif

%post libs
/sbin/ldconfig

%postun libs
/sbin/ldconfig

%post gtk
%{_bindir}/update-gtk-immodules %{_host} || :

%postun gtk
%{_bindir}/update-gtk-immodules %{_host} || :

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING README
%config %{_sysconfdir}/X11/xinit/xim.d/ibus
%config %{_sysconfdir}/X11/xinit/xim.d/ibus-qt3
%config %{_xinputconf}
%{_sysconfdir}/gconf/schemas/ibus.schemas
# %%{_sysconfdir}/xdg/autostart/ibus.desktop
%{_bindir}/ibus-daemon
%{_bindir}/ibus-setup
%{_libdir}/girepository-1.0/IBus-1.0.typelib
%{python_sitelib}/ibus
%{_libexecdir}/ibus-gconf
%{_libexecdir}/ibus-ui-gtk
%{_libexecdir}/ibus-x11
%{_datadir}/ibus
%{_datadir}/applications/*
# %%{_datadir}/pixmaps/*
%{_datadir}/icons/hicolor/*/*/*

%files libs
%defattr(-,root,root,-)
%{_libdir}/libibus.so.*

%files gtk
%defattr(-,root,root)
%{_libdir}/gtk-2.0/%{gtk_binary_version}/immodules/im-ibus.so

%if 0
%files qt
%defattr(-,root,root)
%{_libdir}/qt4/plugins/inputmethods/libibus.so
%endif

%files devel
%defattr(-,root,root,-)
%{_libdir}/lib*.so
%{_includedir}/*
%{_libdir}/pkgconfig/*
%{_datadir}/gir-1.0/IBus-1.0.gir
%{_datadir}/vala/vapi/ibus-1.0.vapi

%files devel-docs
%defattr(-,root,root,-)
%{_datadir}/gtk-doc/html/*

%changelog
* Thu Nov 25 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.3.9-1m)
- update 1.3.9

* Tue Oct 26 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.3.8-1m)
- update 1.3.8
-- many bugfix release
- enable-introspection

* Sun Oct  3 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.3.7-5m)
- disable-introspection

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.3.7-4m)
- full rebuild for mo7 release

* Thu Aug 26 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.3.7-3m)
- the language panel appears in only active as default (Patch2)

* Thu Aug 19 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.3.7-2m)
- use Shift+Space as trigger

* Sat Aug  7 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.3.7-1m)
- update to 1.3.7

* Sat Jul 31 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.3.6-2m)
- modify %%post and %%postun gtk for new gtk2

* Tue Jul  6 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (1.3.6-1m)
- update to 1.3.6

* Sun Jun 20 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.3.5-3m)
- vapi and gir to devel

* Tue Jun 15 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.3.5-2m)
- fix build with gobject-introspection and vala
- sort %%files

* Sun Jun 13 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.3.5-1m)
- update 1.3.5

* Thu May 13 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.3.3-1m)
- update 1.3.3

* Thu May  6 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.3.2-1m)
- update 1.3.2

* Tue May  4 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.2.0.20100111-4m)
- revise xinput-ibus

* Tue May  4 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.2.0.20100111-3m)
- install Qt3 support configuration file for sdr and gdm
- update xinput-ibus

* Mon Feb  1 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.2.0.20100111-2m)
- --enable-gtk-doc

* Thu Jan 21 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.2.0.20100111-1m)
- update 1.2.0.20100111

* Mon Dec 28 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.2.0.20091225-1m)
- fix %%postun error

* Sun Dec 27 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.2.0.20091225-1m)
- update 1.2.0.20091225

* Sun Dec 20 2009 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.2.0.20091215-2m)
- --disable-gtk-doc

* Thu Dec 17 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.2.0.20091215-1m)
- update 1.2.0.20091215

* Tue Nov 24 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.2.0.20091124-1m)
- update 1.2.0.20091124

* Tue Nov 24 2009 Masanobu Sato <satoshiga@momonga-linux.org>
- (1.2.0.20090927-3m)
- modified xinput-ibus for Momonga's xinit system

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.2.0.20090927-2m)
- rebuild against gcc-4.4 and glibc-2.11

* Sun Oct  4 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.2.0.20090927-1m)
- update to 1.2.0.20090927

* Thu Jul 30 2009 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.0-0.20090612.2m)
- rebuild against qt-4.5.2-1m

* Thu Jun 18 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.1.0-0.20090612.1m)
- update 1.1.0-0.20090612

* Wed Jun  3 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.1.0-0.20090531.1m)
- update 1.1.0-0.20090531

* Sat May  9 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.1.0-0.20090508.3m)
- remove desktop.patch

* Sat May  9 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.1.0-0.20090508.2m)
- stop using autogen.sh to enable build
- re-enable qt4-immodule
- update and re-apply desktop.patch

* Sat May  9 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.1.0-0.20090508.1m)
- update 1.1.0-0.20090508

* Fri May  9 2009 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.0-0.20090407.2m)
- rebuild against qt-4.5.1-1m

* Tue Apr  7 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.1.0-0.20090407.1m)
- update 1.1.0-0.20090407

* Wed Apr  1 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.1.0-0.20090311.2m)
- remove duplicate files

* Mon Mar 16 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.1.0-0.20090311.1m)
- update 1.1.0-0.20090311

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.1.1-0.20081023.2m)
- rebuild against rpm-4.6

* Sat Jan  3 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20081023.1m)
- update 0.1.1-0.20081023

* Sat Oct 18 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20081016.1m)
- update 0.1.1-0.20081016

* Fri Oct 10 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20081006.1m)
- update 0.1.1-0.20081006

* Sun Oct  5 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20081004.1m)
- update 0.1.1-0.20081004

* Wed Oct  1 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20081001.1m)
- update 0.1.1-0.20081001

* Tue Sep 23 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20080923.1m)
- update 0.1.1-0.20080923

* Wed Sep 17 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20080917.1m)
- update 0.1.1-0.20080917

* Mon Sep 15 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20080914.1m)
- update 0.1.1-0.20080914

* Mon Sep 15 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.1.1-0.20080908.1m)
- update 0.1.1

* Tue Aug 19 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.1.0-0.20080819.1m)
- update to 20080819 git snapshot

* Tue Aug 19 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.1.0-0.20080810.2m)
- add Name[ja] to ibus-setup.desktop

* Tue Aug 19 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.1.0-0.20080810.1m)
- initial package for Momonga Linux
